//+------------------------------------------------------------------+
//|                                               luktom infobar.mq4 |
//|                                   ukasz Tomaszkiewicz :: luktom |
//|                                               http://luktom.biz/ |
//+------------------------------------------------------------------+
#property copyright "luktom"
#property link      "http://luktom.biz/"

#property indicator_chart_window

extern int Margin=110;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   createlabel("spreadlabel",20+Margin,"Spread");
   
   int spread=MarketInfo(Symbol(),MODE_SPREAD);
   createlabel("spread",5+Margin,spread,Yellow);
   
   int tickvalue=MarketInfo(Symbol(),MODE_TICKVALUE);
   createlabel("tickvaluelabel",77+Margin,"Tick value");
   createlabel("tickvalue",62+Margin,tickvalue,Yellow);
   
   double swaplong=MarketInfo(Symbol(),MODE_SWAPLONG);
   createlabel("swaplonglabel",175+Margin,"Swap long");
   createlabel("swaplong",135+Margin,DoubleToStr(swaplong,4),Yellow);
   
   double swapshort=MarketInfo(Symbol(),MODE_SWAPSHORT);
   createlabel("swapshortlabel",275+Margin,"Swap short");
   createlabel("swapshort",235+Margin,DoubleToStr(swapshort,4),Yellow);
   
   double time=MarketInfo(Symbol(),MODE_TIME);
   createlabel("timelabel",380+Margin,"Czas");
   createlabel("time",335+Margin,TimeHour(time) + ":" + TimeMinute(time) + ":" + TimeSeconds(time),Yellow);
   
   createlabel("rangelabel",435+Margin,"Zakres");
   createlabel("range",410+Margin,DoubleToStr((iHigh(NULL,PERIOD_D1,0)-iLow(NULL,PERIOD_D1,0))/MarketInfo(Symbol(),MODE_POINT),0),Yellow);
   
   createlabel("yrangelabel",500+Margin,"Wczorajszy zakres");
   createlabel("yrange",475+Margin,DoubleToStr((iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/MarketInfo(Symbol(),MODE_POINT),0),Yellow);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("spreadlabel");
   ObjectDelete("spread");
   ObjectDelete("tickvaluelabel");
   ObjectDelete("tickvalue");
   ObjectDelete("swaplonglabel");
   ObjectDelete("swaplong");
   ObjectDelete("swapshortlabel");
   ObjectDelete("swapshort");
   ObjectDelete("timelabel");
   ObjectDelete("time");
   ObjectDelete("rangelabel");
   ObjectDelete("range");
   ObjectDelete("yrangelabel");
   ObjectDelete("yrange");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----
   RefreshRates();  
   double time=MarketInfo(Symbol(),MODE_TIME);
   ObjectSetText("time", TimeHour(time) + ":" + TimeMinute(time) + ":" + TimeSeconds(time), 8);   
   
   ObjectSetText("range",DoubleToStr((iHigh(NULL,PERIOD_D1,0)-iLow(NULL,PERIOD_D1,0))/MarketInfo(Symbol(),MODE_POINT),0),8);
   ObjectSetText("yrange",DoubleToStr((iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/MarketInfo(Symbol(),MODE_POINT),0),8);
//----
   return(0);
  }
//+------------------------------------------------------------------+

void createlabel(string name, int x, string text="", color cl=White) {
 ObjectCreate(name, OBJ_LABEL, 0, 0, 0);
 ObjectSet(name, OBJPROP_CORNER, 1);
 ObjectSet(name, OBJPROP_COLOR, cl);          
 ObjectSet(name, OBJPROP_XDISTANCE, x);          
 ObjectSet(name, OBJPROP_YDISTANCE, 1);          
 ObjectSet(name, OBJPROP_BACK, true);          
 ObjectSetText(name, text, 8);         
}